# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "bcsxp"


def test_query(self):
    worklist = self.decode(
        """
    H|\\^&|||BCSXP^1.1^^H1P1O1R1C1Q1L1^1.1|||||||P|1|20050705150034
    Q|1|^99988800||^^^ALL||||||||O
    L|1"""
    )
    expected = {
        "context": "query",
        "samples": [{"type": "patient", "sample_id": "99988800"}],
    }
    assert worklist == expected


def test_order(self):
    message = self.order()
    expected = """
    H|\\^&|||MCA|||||||P|1
    P|1|036666666|L036666666||NYME^ANO|||F
    O|1||123456|^^^A\\^^^B|S|||||||||||PRESCRIBER|||||||||O
    L|1"""
    assert message == expected


def test_decode_result(self):
    date = datetime.datetime(2013, 7, 5, 3, 2, 8)
    worklist = self.decode(
        """
    H|\\^&|||BCSXP^1.1^^H1P1O1R1C1Q1L1^1.1|||||||P|1|20050705150234
    P|1|O00135|||Mustermann^Martin^||19541015|U
    O|1|00136||^^^1|R||||||||||||||||||||F
    R|1|^^^1^PT.sec.TS^^^F|14.386|sec||||F||||20130705030208
    C|1|I|ResultFlag 0|G
    L|1"""
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "type": "patient",
                "sample_id": "00136",
                "results": [
                    {
                        "code": "1",
                        "value": "14.386",
                        "date": date,
                        "dilution": "",
                        "flags": ["ResultFlag 0"],
                    }
                ],
            }
        ],
    }
    assert worklist == expected
